# coding=utf-8
r"""
This code was generated by
\ / _    _  _|   _  _
 | (_)\/(_)(_|\/| |(/_  v1.0.0
      /       /
"""

from tests import IntegrationTestCase
from tests.holodeck import Request
from twilio.base.exceptions import TwilioException
from twilio.http.response import Response


class UserRolesTestCase(IntegrationTestCase):

    def test_fetch_request(self):
        self.holodeck.mock(Response(500, ''))

        with self.assertRaises(TwilioException):
            self.client.flex_api.v1.user_roles().fetch(token="token")

        headers = {'Token': "token", }
        self.holodeck.assert_has_request(Request(
            'get',
            'https://flex-api.twilio.com/v1/Accounts/UserRoles',
            headers=headers,
        ))

    def test_fetch_response(self):
        self.holodeck.mock(Response(
            200,
            '''
            {
                "roles": [
                    "wfo.full_access"
                ],
                "url": "https://flex-api.twilio.com/v1/Accounts/UserRoles"
            }
            '''
        ))

        actual = self.client.flex_api.v1.user_roles().fetch()

        self.assertIsNotNone(actual)
